﻿<?php
	//futáshoz szükséges állományok felsorolása
	require_once('../../config.php');
	require_once('ozekisend.php');
	
	//az oldal használatához szükséges jogok ellenőrzése
	require_login();
	 
	//paraméterek az oldal futásához
	$courseid 	= optional_param('courseid', 0, PARAM_INT); //ez egy szükséges paraméter, a hivatkozó link által kapja;
	$recipient	= optional_param('recipient', array()); 	// kiválasztott felhasználók telefonszámai
	$text		= optional_param('text','', PARAM_TEXT);	//elküldendő üzenet
	
	$sms_send_success = -1; //sms küldés hibakódja ha -1 akkor még nem került elküldésre sms, ha 0 akkor sikeres volt a küldés, ha egyéb más szám akkor az hibakód
	
	
	//ha nem létezik a kurzus akkor hibaüzenet
	if (! $course = get_record('course', 'id', $courseid)) {
        print_error("invalidcourse");
    }
	
	//lekérjük a körhnyezet adatait és ha érvénytelen környezet akkor hibaüznet
    if (! $context = get_context_instance(CONTEXT_COURSE, $course->id)) {
		print_error("invalidcontext");
    }
	
	//szerepköreim meghatározása
	$my_roles=get_user_roles($context,$USER->id);
	$my_highest_role=5;
	//legmagasabb szerepkör meghatározása
	foreach ($my_roles as $my_role) {
		if ($my_highest_role > $my_role->roleid){	
			$my_highest_role = $my_role->roleid;
		}
	}
	//ha admin felhasználó akkor lekérjük neki az összes kurzust
	if ($my_highest_role==1) {
		$my_courses=get_courses();
	}
	//egyébként csak azokat a kurzusokat, amelyekhez hozzá van rendelve
	else {
		//azon kurzusok lekérése amelyeket láthat a bejelentkezett felhasználó
		$my_courses=get_my_courses($USER->id);
	}
	
	//ha nincs felkonfigurálva a modul akkor hibát jelez
	if ($CFG->block_ozekismsc_host == '' || $CFG->block_ozekismsc_port == '' || $CFG->block_ozekismsc_user == '' || $CFG->block_ozekismsc_password == '') {
		print_error('noconfig','block_ozekismsc');
	}
	
	//ha nincs beiratkozva a kurzusra akkor elnavigál a kurzus beiratkozó oldalára
	require_login($course);
	
	// kurzus felhasználóinak lekérése
	// ha nem nyitó oldalon vagyunk
	if ($courseid!=SITEID){
		//akkor az összes a kiválasztott kurzusra beiratkozott tanulót megjelenítjük
		if (!$courseusers = get_users_by_capability($context, 'moodle/course:view', 'u.*', 'u.lastname, u.firstname', '', '', '', '', false)) {
			//ha nincs ilyen hibaüzenet
			print_error('nocourseuser','block_ozekismsc');
		}
	}
	else {
		//egyébként az oldal összes felhasználóját listázzuk
		$courseusers = get_users_confirmed();
	}
	//smsek küldése
	//ha volt címzett kiválasztva és van szöveg is akkor 
	if (count($recipient)!=0 && $text!='') {
		//beállítjuk hogy sikeres lesz az sms küldés
		$sms_send_success = 0;
		//inicializáljuk az osztályt
		$os = new ozekisend($CFG->block_ozekismsc_host,$CFG->block_ozekismsc_port,$CFG->block_ozekismsc_user,$CFG->block_ozekismsc_password);
		//minden címzettnek elküldjük az sms-t
		foreach ($recipient as $phone) {
			$response=$os->ozekisend($phone,$text,FALSE);
			$pieces=explode('<?xml',$response);
			$xml_to_use ='<?xml'.$pieces[1];
			$p = xml_parser_create();
			if (0==xml_parse_into_struct($p, $xml_to_use, $vals, $index)) {
				$ozeki_out = get_string('xml_error','block_ozekismsc');
			}
			xml_parser_free($p);
			//ha valamelyik üzenet küldése hibakóddal tér vissza tehát nem 0 akkor azt a kódot beleírjuk a $sms_send_success változóba
			if ($vals['5']['value']!=0) {
				$sms_send_success = $vals['5']['value'];
			}
		}
	}
	
/******************************************
             Megjelenítő rész
******************************************/	
	
	//navigációs linkek összeállítása
	$navlinks = array();
    $navlinks[] = array('name' => get_string('sendTitle','block_ozekismsc'), 'link' => null, 'type' => 'misc');
    $navigation = build_navigation($navlinks);
	//fejrész kiíratása
	print_header(get_string('blockname','block_ozekismsc'),get_string('sendTitle','block_ozekismsc'),$navigation);
	//oldal tartalmának kiíratása
	print('<script language="javascript" type="text/javascript">
			function limitText(limitField, limitCount, limitNum) {
				if (limitField.value.length > limitNum) {
					limitField.value = limitField.value.substring(0, limitNum);
				} 
				else {
					limitCount.value = limitNum - limitField.value.length;
				}
			}
			function check_uncheck_All(formbox, sel_all, inv){
				for (var i=0;i<formbox.elements.length;i++) {
					var e = formbox.elements[i];
					if ((e.type==\'checkbox\') && (!e.disabled) ) {
						if (sel_all){
							e.checked = true;
						}
						else if (inv) {
							if (e.checked == true) {
								e.checked = false;
							}
							else {
								e.checked = true;
							}
						}
						else {
							e.checked = false;
						}
					}
				}
			}
		</script>');
	print("<hr>");
	//külső div
	print('<div style="text-align:center; margin:0px auto 0px auto; width:800px; border-style:solid; border-width:1px; border-color:black; margin-top:30px;">');
	//bal oldali hasáb
	print("<div style='border-style:solid; border-width:0px; border-color:red; width:197px; float:left; text-align:center;'>");
	print("<span style='font-weight:bold;'>".get_string('myCourses','block_ozekismsc')."</span><br><hr>");
	foreach ($my_courses as $my_course) {
		print("<a href='?courseid=".$my_course->id."'>".$my_course->fullname."</a><br />");
		//print($my_course->fullname.' '.$my_course->id);
	}
	//print_r($my_courses);
	print("</div>");
	//jobb oldali hasáb
	print("<div style='border-style:solid; border-width:0px; border-color:green; width:598px; float:left;'>");
	print('<span style="font-weight:bold;">'.get_string('blockname','block_ozekismsc').'</span>');
	print('<hr>&nbsp ');
	//ha sikeres volt az összes sms küldése akkor a változóban 0 maradt és sikeres üzenetet írunk ki
	if ($sms_send_success==0) {
		print('<span style="color:green;">'.get_string('sendSuccess','block_ozekismsc').'</span>');
	}
	//egyébként ha nem -1 van a változóban akkor hibaüzenetet írunk ki.
	elseif ($sms_send_success!=-1) {
		print('<span style="color:red;">'.get_string('sendFailed','block_ozekismsc').'</span>');				
	}
	print('<hr>');
	print('<form name="ozeki" method="post" action="send.php"> ');
	print(get_string('message','block_ozekismsc').'<br />');
	
	print('<textarea rows="5" cols="30" name="text" onKeyDown="limitText(this.form.text,this.form.countdown,160);" onKeyUp="limitText(this.form.text,this.form.countdown,160);"></textarea><br/>			
			<input readonly type="text" name="countdown" size="3" value="160">'.get_string('chrLeft','block_ozekismsc').'<br />');
	print('<input type="submit" value="'.get_string('sendsms','block_ozekismsc').'">');
	print('<input type="hidden" name="courseid" value="'.$courseid.'">');
	print('<hr>');	
	print('<table style="width:100%">');
	print('<tr><td style="font-weight:bold">'.get_string('name','block_ozekismsc').'</td><td style="font-weight:bold">'.get_string('phoneNum','block_ozekismsc').'</td><td style="font-weight:bold">'.get_string('select','block_ozekismsc').'</td></tr>');
	print("\n");
	$i=1;
	foreach ($courseusers as $user) {
		if ($user->phone2!='') {
			if ($i % 2 == 0){
				print('<tr><td>'.$user->lastname.' '.$user->firstname.'</td><td>'.$user->phone2.'</td><td><input type="checkbox" name="recipient[]" value="'.$user->phone2.'"></td></tr>');
			}
			else {
				print('<tr style="background:#B5B3B3;"><td>'.$user->lastname.' '.$user->firstname.'</td><td>'.$user->phone2.'</td><td><input type="checkbox" name="recipient[]" value="'.$user->phone2.'"></td></tr>');
			}
			print("\n");
			$i++;
		}	
		
	}
	print('</table>');
	print('<hr>');
	print('<input type="button" value="'.get_string('select','block_ozekismsc').'" onClick="check_uncheck_All(document.ozeki,true,false)"> ');
	print('<input type="button" value="'.get_string('deselect','block_ozekismsc').'" onClick="check_uncheck_All(document.ozeki,false,false)"> ');
	print('<input type="button" value="'.get_string('invert','block_ozekismsc').'" onClick="check_uncheck_All(document.ozeki,false,true)">');
	print('</form>');
	print('</div>');
	//floatlezárás
	print("<div style='clear:both;'></div>");
	print('</div>');
	//lábléc kiíratása
	print_footer($course);
?>
